VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   7035
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   9870
   LinkTopic       =   "Form1"
   ScaleHeight     =   7035
   ScaleWidth      =   9870
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HScroll1 
      Height          =   285
      Left            =   210
      Max             =   360
      TabIndex        =   2
      Top             =   6630
      Width           =   9555
   End
   Begin VB.PictureBox Picture1 
      Height          =   5775
      Left            =   180
      ScaleHeight     =   5715
      ScaleWidth      =   9525
      TabIndex        =   1
      Top             =   780
      Width           =   9585
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   210
      TabIndex        =   0
      Top             =   180
      Width           =   1995
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private GdipInitialized As Boolean
Private m_lngOrgBitmap As Long
Private m_lngPrevBitmap As Long
Private m_sngOrgWidth As Single
Private m_sngOrgHeight As Single
Private m_sngPrevWidth As Single
Private m_sngPrevHeight As Single
Private m_sngRotationWidth As Single
Private m_sngRotationHeight As Single
Private m_lngOrgPixelFormat As PixelFormats

Private Sub Form_Load()

    GdipInitialized = False
    
    With Picture1
        .ScaleMode = vbPixels
        .BackColor = vbWhite
        .AutoRedraw = True
    End With

    If Execute(StartUpGDIPlus) = OK Then

        GdipInitialized = True

    Else

        MsgBox "GDI+ konnte nicht initialisiert werden.", vbOKOnly, "GDI+ Error"

    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    If GdipInitialized = True Then
    
        If m_lngOrgBitmap <> 0& Then Call Execute(GdipDisposeImage(m_lngOrgBitmap))
        If m_lngPrevBitmap <> 0& Then Call Execute(GdipDisposeImage(m_lngPrevBitmap))

        Call Execute(ShutdownGDIPlus)

    End If

End Sub

Private Sub HScroll1_Scroll()

    Call HScroll1_Change
    
End Sub

Private Sub HScroll1_Change()

    If CalcRotationBitmapSize(m_lngPrevBitmap, _
                              CSng(HScroll1.Value), _
                              m_sngPrevWidth, _
                              m_sngPrevHeight, _
                              m_sngRotationWidth, _
                              m_sngRotationHeight) = True Then
                
        Call ShowPreviewRotationBitmap(m_lngPrevBitmap, _
                                       CSng(HScroll1.Value), _
                                       m_sngRotationWidth, _
                                       m_sngRotationHeight, _
                                       m_lngOrgPixelFormat, _
                                       Picture1)
            
    End If

End Sub

Private Sub Command1_Click()
    
    Dim strFileName As String
    Dim sngRotationWidth As Single
    Dim sngRotationHeight As Single

    If GdipInitialized = True Then
    
        If m_lngOrgBitmap <> 0& Then Call Execute(GdipDisposeImage(m_lngOrgBitmap))
        If m_lngPrevBitmap <> 0& Then Call Execute(GdipDisposeImage(m_lngPrevBitmap))

        strFileName = App.Path & "\test.jpg"

        If LoadImagePlus(strFileName, _
                         m_lngOrgBitmap, _
                         m_sngOrgWidth, _
                         m_sngOrgHeight, _
                         m_lngOrgPixelFormat) = True Then
                         
            If CreatePreviewBitmap(m_lngOrgBitmap, _
                                   Picture1.ScaleWidth, _
                                   Picture1.ScaleHeight, _
                                   m_lngOrgPixelFormat, _
                                   m_sngPrevWidth, _
                                   m_sngPrevHeight, _
                                   m_lngPrevBitmap) = True Then

                
                If CalcRotationBitmapSize(m_lngPrevBitmap, 0, _
                                          m_sngPrevWidth, _
                                          m_sngPrevHeight, _
                                          m_sngRotationWidth, _
                                          m_sngRotationHeight) = True Then
                
                    Call ShowPreviewRotationBitmap(m_lngPrevBitmap, 0, _
                                                   m_sngRotationWidth, _
                                                   m_sngRotationHeight, _
                                                   m_lngOrgPixelFormat, _
                                                   Picture1)
            
                End If
            
            End If
    
        End If
    
    End If

End Sub

